Index: tmp/org.txm.dictionary.rcp/src/org/txm/dictionary/functions/jpa/Dictionary.java
===================================================================
--- tmp/org.txm.dictionary.rcp/src/org/txm/dictionary/functions/jpa/Dictionary.java	(revision 489)
+++ tmp/org.txm.dictionary.rcp/src/org/txm/dictionary/functions/jpa/Dictionary.java	(revision 490)
@@ -31,7 +31,7 @@
 import org.eclipse.persistence.queries.Cursor;
 import org.txm.Toolbox;
 import org.txm.annotation.DatabasePersistenceManager;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.stat.utils.ConsoleProgressBar;
 import org.txm.utils.logger.Log;
 
@@ -62,7 +62,7 @@
 		addEntries(ids, null);
 	}
 
-	private void addEntries(ArrayList<EntryId> ids, ProgressWatcher monitor) {
+	private void addEntries(ArrayList<EntryId> ids, IProgressMonitor monitor) {
 		jpaem.getTransaction().begin();
 
 		for (EntryId t : ids) {
@@ -135,11 +135,11 @@
 		addTypes(types, null);
 	}
 
-	public void addTypes(ArrayList<EntryPropertyType> types, ProgressWatcher monitor) {
+	public void addTypes(ArrayList<EntryPropertyType> types, IProgressMonitor monitor) {
 		jpaem.getTransaction().begin();
 		for (EntryPropertyType t : types) {
 			jpaem.persist(t);
-			if (monitor != null) monitor.worked();
+			if (monitor != null) monitor.worked(1);
 			autoFlush();
 		}
 		jpaem.getTransaction().commit();
Index: tmp/org.txm.querycooccurrences.rcp/src/org/txm/functions/coocmatrix/QueryAutoCooccurrence.java
===================================================================
--- tmp/org.txm.querycooccurrences.rcp/src/org/txm/functions/coocmatrix/QueryAutoCooccurrence.java	(revision 489)
+++ tmp/org.txm.querycooccurrences.rcp/src/org/txm/functions/coocmatrix/QueryAutoCooccurrence.java	(revision 490)
@@ -9,7 +9,7 @@
 import org.txm.ca.core.functions.CA;
 import org.txm.ca.core.functions.ICAComputable;
 import org.txm.core.results.TXMResult;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
 import org.txm.rcp.IImageKeys;
@@ -44,7 +44,7 @@
 	protected boolean oriented = false;
 
 	public QueryAutoCooccurrence(Corpus corpus, ArrayList<Query> queries, 
-			ArrayList<String> names, int dist, int minCooc, String struct, boolean oriented, ProgressWatcher monitor) throws CqiClientException, RWorkspaceException {
+			ArrayList<String> names, int dist, int minCooc, String struct, boolean oriented, IProgressMonitor monitor) throws CqiClientException, RWorkspaceException {
 		this.queries = queries;
 		this.names = names;
 		this.corpus = corpus;
Index: tmp/org.txm.searchengine.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.core/META-INF/MANIFEST.MF	(revision 489)
+++ tmp/org.txm.searchengine.core/META-INF/MANIFEST.MF	(revision 490)
@@ -4,8 +4,7 @@
 Bundle-SymbolicName: org.txm.searchengine.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Bundle-Activator: org.txm.searchengine.core.Activator
-Require-Bundle: org.txm.annotation.core;bundle-version="1.0.0",
- org.eclipse.core.runtime,
+Require-Bundle: org.eclipse.core.runtime,
  org.txm.core;bundle-version="0.7.0",
  org.txm.utils
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 489)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 490)
@@ -42,7 +42,7 @@
 
 import org.apache.commons.lang.StringUtils;
 import org.eclipse.osgi.util.NLS;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.functions.TXMCommand;
 import org.txm.index.core.messages.IndexCoreMessages;
 import org.txm.lexicon.core.corpusengine.cqp.Lexicon;
@@ -1017,7 +1017,7 @@
 
 
 	@Override
-	public boolean compute(ProgressWatcher watcher) throws Exception {
+	public boolean compute(IProgressMonitor watcher) throws Exception {
 		if (query != null) {
 			if (parent instanceof Corpus) {
 				Corpus corpus = (Corpus)parent;
Index: tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF	(revision 489)
+++ tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF	(revision 490)
@@ -5,8 +5,7 @@
 Bundle-Version: 1.0.0.qualifier
 Bundle-Vendor: Textometrie.org
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
-Require-Bundle: org.txm.annotation.core;bundle-version="1.0.0",
- org.eclipse.core.runtime;bundle-version="3.10.0",
+Require-Bundle: org.eclipse.core.runtime;bundle-version="3.10.0",
  org.eclipse.ui;bundle-version="3.106.1",
  org.txm.cooccurrence.core;bundle-version="1.0.0",
  org.txm.cooccurrence.rcp;bundle-version="1.0.0",
@@ -17,8 +16,8 @@
  org.txm.core,
  org.txm.rcp,
  org.eclipse.core.expressions;bundle-version="3.4.600",
- org.txm.para.rcp,
- org.txm.searchengine.core;bundle-version="1.0.0"
+ org.txm.searchengine.core;bundle-version="1.0.0",
+ org.txm.annotation.core;bundle-version="1.0.0"
 Export-Package: org.txm.concordance.rcp.adapters,
  org.txm.concordance.rcp.editors,
  org.txm.concordance.rcp.handlers,
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 489)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 490)
@@ -100,6 +100,7 @@
 import org.txm.Toolbox;
 import org.txm.annotation.Annotation;
 import org.txm.annotation.AnnotationManager;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.annotation.repository.AnnotationType;
 import org.txm.annotation.repository.KnowledgeRepository;
 import org.txm.annotation.repository.KnowledgeRepositoryManager;
@@ -427,7 +428,7 @@
 
 	private void initializeEditor() {
 		this.corpus = ((ConcordanceEditorInput) getEditorInput()).getCorpus();
-		this.annotManager = corpus.getAnnotationManager();
+		this.annotManager = KRAnnotationEngine.getAnnotationManager(corpus);
 
 		this.standardComparators = new ArrayList<LineComparator>();
 		this.userDefinedComparators = new ArrayList<LineComparator>();
@@ -1022,6 +1023,8 @@
 		Log.warning("Corpus KRs: "+krs); //$NON-NLS-1$
 
 		for (KnowledgeRepository kr : krs) {
+			if (kr == null) continue;
+			
 			currentKnowledgeRepository = kr;
 			Log.warning(" KR: "+kr); //$NON-NLS-1$
 			List<AnnotationType> krtypes = kr.getAllAnnotationTypes();
@@ -1045,6 +1048,11 @@
 			Log.warning("Available annotation types: "+typesList);
 			break;
 		}
+		
+		if (currentKnowledgeRepository == null) {
+			System.out.println("Error: no suitable KnowledgeRepository found");
+			return;
+		}
 
 		annotationArea = new Composite(parent, SWT.NONE);
 		annotationArea.setLayoutData(new GridData(SWT.FILL, SWT.LEFT, false, false));
@@ -1790,7 +1798,7 @@
 		});
 
 
-		if (corpus.getKnowledgeRepositoryNames().size() > 0) { // shown only if corpus has a registered KR
+		if (KRAnnotationEngine.getKnowledgeRepositoryNames(corpus).size() > 0) { // shown only if corpus has a registered KR
 
 			annotationButton = new Button(navigationPanel, SWT.PUSH);
 			annotationButton.setToolTipText(Messages.ConcordancesEditor_75);
@@ -1799,7 +1807,7 @@
 				@Override
 				public void widgetSelected(SelectionEvent e) {
 					if (annotationArea != null) {
-						AnnotationManager am = corpus.getMainCorpus().getAnnotationManager();
+						AnnotationManager am = KRAnnotationEngine.getAnnotationManager(corpus);
 						if (am != null && am.hasChanges()) {
 							// && MessageDialog.openConfirm(e.display.getActiveShell(), "Confirm annotation save", "Saving annotation will close this editor. Are you sure you want to save annotations right now ?")
 							JobHandler saveJob = SaveAnnotations.save(corpus.getMainCorpus());
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/DefineSortReferencePattern.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/DefineSortReferencePattern.java	(revision 489)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/DefineSortReferencePattern.java	(revision 490)
@@ -47,7 +47,6 @@
 import org.eclipse.ui.IWorkbenchWindow;
 import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
 import org.txm.concordance.rcp.editors.ConcordanceEditor;
-import org.txm.para.rcp.editors.ParaBrowserEditor;
 import org.txm.rcp.Messages;
 import org.txm.searchengine.cqp.ReferencePattern;
 import org.txm.searchengine.cqp.corpus.Property;
@@ -70,9 +69,6 @@
 	/** The concordance editor. */
 	private ConcordanceEditor concordanceEditor;
 	
-	/** The para browser editor. */
-	private ParaBrowserEditor paraBrowserEditor;
-
 	/**
 	 * Instantiates a new define reference pattern.
 	 *
@@ -88,22 +84,6 @@
 		setToolTipText(Messages.DefineReferencePattern_4);
 	}
 
-	/**
-	 * Instantiates a new define reference pattern.
-	 *
-	 * @param window the window
-	 * @param paraBrowserEditor the para browser editor
-	 */
-	public DefineSortReferencePattern(IWorkbenchWindow window,
-			ParaBrowserEditor paraBrowserEditor) {
-		this.window = window;
-		this.paraBrowserEditor = paraBrowserEditor;
-		setId(ID);
-		setText(Messages.DefineReferencePattern_3);
-		setToolTipText(Messages.DefineReferencePattern_4);
-	}
-
-	
 	/* (non-Javadoc)
 	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
 	 */
@@ -119,19 +99,11 @@
 		List<StructuralUnit> structuralUnits = null;
 		List<Property> availableReferenceItems = new ArrayList<Property>();
 		try {
-			if (paraBrowserEditor != null) {
-				structuralUnits = paraBrowserEditor.getCorpus()
-						.getOrderedStructuralUnits();
-				availableReferenceItems.addAll(paraBrowserEditor.getCorpus()
-						.getOrderedProperties());
-
-			} else if (concordanceEditor != null) {
 				structuralUnits = concordanceEditor.getCorpus()
 						.getOrderedStructuralUnits();
 				availableReferenceItems.addAll(concordanceEditor.getCorpus()
 						.getOrderedProperties());
 
-			}
 
 		} catch (Exception e) {
 			org.txm.rcp.utils.Logger.printStackTrace(e);
@@ -143,34 +115,18 @@
 
 		// System.out.println("selected "+concordanceEditor.getSelectedReferences());
 		// System.out.println("before avail"+availableReferenceItems);
-		if (paraBrowserEditor != null) {
-			availableReferenceItems.remove(paraBrowserEditor
-					.getSelectedReferences());
-		} else {
 			availableReferenceItems.remove(concordanceEditor
 					.getSelectedSortReferences());
-		}
 
-		// System.out.println("after avail"+availableReferenceItems);
+			// System.out.println("after avail"+availableReferenceItems);
 		DefineReferencePatternDialog d = null;
-		if (paraBrowserEditor != null) {
 			d = new DefineReferencePatternDialog(window.getShell(),
-					availableReferenceItems, paraBrowserEditor
-							.getSelectedReferences());
-		} else if (concordanceEditor != null) {
-			d = new DefineReferencePatternDialog(window.getShell(),
 					availableReferenceItems, concordanceEditor
 							.getSelectedSortReferences());
-		}
 
 		if (d.open() == Window.OK) {
-			if (paraBrowserEditor != null) {
-				paraBrowserEditor.setReferencePattern(new ReferencePattern(d
-						.getSelectesdReferenceItems()));
-			} else if (concordanceEditor != null) {
 				concordanceEditor.setRefSortPattern(new ReferencePattern(d
 						.getSelectesdReferenceItems()));
-			}
 			//System.out.println(concordanceEditor.getSortReferencePattern());
 		}
 	}
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/DefineViewReferencePattern.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/DefineViewReferencePattern.java	(revision 489)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/actions/DefineViewReferencePattern.java	(revision 490)
@@ -47,7 +47,6 @@
 import org.eclipse.ui.IWorkbenchWindow;
 import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
 import org.txm.concordance.rcp.editors.ConcordanceEditor;
-import org.txm.para.rcp.editors.ParaBrowserEditor;
 import org.txm.rcp.Messages;
 import org.txm.searchengine.cqp.ReferencePattern;
 import org.txm.searchengine.cqp.corpus.Property;
@@ -70,9 +69,6 @@
 	/** The concordance editor. */
 	private ConcordanceEditor concordanceEditor;
 	
-	/** The para browser editor. */
-	private ParaBrowserEditor paraBrowserEditor;
-
 	/**
 	 * Instantiates a new define reference pattern.
 	 *
@@ -88,22 +84,6 @@
 		setToolTipText(Messages.DefineReferencePattern_2);
 	}
 
-	/**
-	 * Instantiates a new define reference pattern.
-	 *
-	 * @param window the window
-	 * @param paraBrowserEditor the para browser editor
-	 */
-	public DefineViewReferencePattern(IWorkbenchWindow window,
-			ParaBrowserEditor paraBrowserEditor) {
-		this.window = window;
-		this.paraBrowserEditor = paraBrowserEditor;
-		setId(ID);
-		setText(Messages.DefineReferencePattern_1);
-		setToolTipText(Messages.DefineReferencePattern_2);
-	}
-
-	
 	/* (non-Javadoc)
 	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
 	 */
@@ -119,20 +99,11 @@
 		List<StructuralUnit> structuralUnits = null;
 		List<Property> availableReferenceItems = new ArrayList<Property>();
 		try {
-			if (paraBrowserEditor != null) {
-				structuralUnits = paraBrowserEditor.getCorpus()
-						.getOrderedStructuralUnits();
-				availableReferenceItems.addAll(paraBrowserEditor.getCorpus()
-						.getOrderedProperties());
-
-			} else if (concordanceEditor != null) {
 				structuralUnits = concordanceEditor.getCorpus()
 						.getOrderedStructuralUnits();
 				availableReferenceItems.addAll(concordanceEditor.getCorpus()
 						.getOrderedProperties());
 
-			}
-
 		} catch (Exception e) {
 			org.txm.rcp.utils.Logger.printStackTrace(e);
 		}
@@ -143,34 +114,18 @@
 
 		// System.out.println("selected "+concordanceEditor.getSelectedReferences());
 		// System.out.println("before avail"+availableReferenceItems);
-		if (paraBrowserEditor != null) {
-			availableReferenceItems.remove(paraBrowserEditor
-					.getSelectedReferences());
-		} else {
 			availableReferenceItems.remove(concordanceEditor
 					.getSelectedViewReferences());
-		}
 
 		// System.out.println("after avail"+availableReferenceItems);
 		DefineReferencePatternDialog d = null;
-		if (paraBrowserEditor != null) {
 			d = new DefineReferencePatternDialog(window.getShell(),
-					availableReferenceItems, paraBrowserEditor
-							.getSelectedReferences());
-		} else if (concordanceEditor != null) {
-			d = new DefineReferencePatternDialog(window.getShell(),
 					availableReferenceItems, concordanceEditor
 							.getSelectedViewReferences());
-		}
 
 		if (d.open() == Window.OK) {
-			if (paraBrowserEditor != null) {
-				paraBrowserEditor.setReferencePattern(new ReferencePattern(d
-						.getSelectesdReferenceItems()));
-			} else if (concordanceEditor != null) {
 				concordanceEditor.setRefViewPattern(new ReferencePattern(d
 						.getSelectesdReferenceItems()));
-			}
 			//System.out.println(concordanceEditor.getViewReferencePattern());
 		}
 	}
Index: tmp/org.txm.ca.core/src/org/txm/ca/core/functions/CA.java
===================================================================
--- tmp/org.txm.ca.core/src/org/txm/ca/core/functions/CA.java	(revision 489)
+++ tmp/org.txm.ca.core/src/org/txm/ca/core/functions/CA.java	(revision 490)
@@ -43,7 +43,7 @@
 import org.txm.ca.core.statsengine.r.functions.ICA;
 import org.txm.chartsengine.core.results.IChartResult;
 import org.txm.core.preferences.TXMPreferences;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.functions.TXMCommand;
 import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.lexicaltable.core.functions.LexicalTableFactory;
@@ -989,7 +989,7 @@
 
 
 	@Override
-	public boolean compute(ProgressWatcher watcher) throws Exception {
+	public boolean compute(IProgressMonitor watcher) throws Exception {
 		return stepLexicalTable() && stepSortTableLexical() && stepCompute();
 	}
 
Index: tmp/org.txm.oriflamms.rcp/src/org/txm/oriflamms/functions/TEI2Project.java
===================================================================
--- tmp/org.txm.oriflamms.rcp/src/org/txm/oriflamms/functions/TEI2Project.java	(revision 489)
+++ tmp/org.txm.oriflamms.rcp/src/org/txm/oriflamms/functions/TEI2Project.java	(revision 490)
@@ -12,7 +12,7 @@
 import org.eclipse.core.runtime.Platform;
 import org.osgi.framework.Bundle;
 import org.txm.Toolbox;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.importer.ApplyXsl2;
 import org.txm.importer.WriteIdAndNAttributes;
 import org.txm.utils.BundleUtils;
@@ -36,7 +36,7 @@
 		this.createArchive = createArchive;
 	}
 	
-	public boolean process(ProgressWatcher monitor) throws IOException, XMLStreamException, TransformerException {
+	public boolean process(IProgressMonitor monitor) throws IOException, XMLStreamException, TransformerException {
 		if (!xmlFile.exists()) {
 			System.out.println("Could not read input XML input file: "+xmlFile);
 			return false;
@@ -125,7 +125,7 @@
 		try {
 
 			System.out.println("Applying "+xslMissingMilestones+" to "+xmlWFile+"...");
-			if (monitor != null) monitor.worked(1, "Applying "+xslMissingMilestones+" to "+xmlWFile+"...");
+			if (monitor != null) { monitor.worked(1); monitor.subTask("Applying "+xslMissingMilestones+" to "+xmlWFile+"...");}
 			ApplyXsl2 builder = new ApplyXsl2(xslMissingMilestones);
 			if (!builder.process(xmlFileCopy, xmlWFile)) {
 				System.out.println("Failed to process "+xmlWFile+" with "+xslMissingMilestones);
@@ -133,7 +133,7 @@
 			}
 
 			System.out.println("Applying "+xslTokenizer+" to "+xmlWFile+"...");
-			if (monitor != null) monitor.worked(15, "Applying "+xslTokenizer+" to "+xmlWFile+"...");
+			if (monitor != null) {monitor.worked(15); monitor.subTask( "Applying "+xslTokenizer+" to "+xmlWFile+"...");};
 			builder = new ApplyXsl2(xslTokenizer);
 			if (!builder.process(xmlWFile, xmlWFile)) {
 				System.out.println("Failed to process "+xmlFileCopy+" with "+xslTokenizer);
@@ -141,7 +141,7 @@
 			}
 
 			System.out.println("Merging words </w><w>");
-			if (monitor != null) monitor.worked(15, "Merging words </w><w>");
+			if (monitor != null) {monitor.worked(15); monitor.subTask("Merging words </w><w>");}
 			String content = IOUtils.getText(xmlWFile, "UTF-8");
 			content = content.replaceAll("</w><w[^>]*>", "");
 			content = content.replaceAll("</w>\\s*(<milestone[^>]*>)?\\s*(<pb[^>]*>)?\\s*(<cb[^>]*>)?\\s*(<lb[^>]*break=\"no\"[^>]*>)\\s*<w[^>]*>", "$1$2$3$4");
@@ -155,7 +155,7 @@
 			}
 
 			System.out.println("Applying "+xslPatchLbInWords+" to "+xmlWFile+"...");
-			if (monitor != null) monitor.worked(15, "Applying "+xslPatchLbInWords+" to "+xmlWFile+"...");
+			if (monitor != null) {monitor.worked(15); monitor.subTask("Applying "+xslPatchLbInWords+" to "+xmlWFile+"...");}
 			builder = new ApplyXsl2(xslPatchLbInWords);
 			if (!builder.process(xmlWFile, xmlWFile)) {
 				System.out.println("Failed to process "+xmlFileCopy+" with "+xslPatchLbInWords);
@@ -163,7 +163,7 @@
 			}
 
 			System.out.println("Fixing 'id' and 'n' attributes in "+xmlWFile+"...");
-			if (monitor != null) monitor.worked(15, "Fixing 'id' and 'n' attributes in "+xmlWFile+"...");
+			if (monitor != null) {monitor.worked(15); monitor.subTask("Fixing 'id' and 'n' attributes in "+xmlWFile+"...");}
 			WriteIdAndNAttributes wiana = new WriteIdAndNAttributes(xmlWFile, projectName);
 			File tmp = new File(xmlWFile.getParentFile(), "tmp_"+xmlWFile.getName());
 			if (!wiana.process(tmp)) {
@@ -180,7 +180,7 @@
 			}
 
 			System.out.println("Applying "+xslCharactersTokenizer+" to "+xmlWFile+"...");
-			if (monitor != null) monitor.worked(15, "Applying "+xslCharactersTokenizer+" to "+xmlWFile+"...");
+			if (monitor != null) {monitor.worked(15); monitor.subTask("Applying "+xslCharactersTokenizer+" to "+xmlWFile+"...");}
 			builder = new ApplyXsl2(xslCharactersTokenizer);
 			if (!builder.process(xmlWFile, xmlWCFile)) {
 				System.out.println("Failed to process "+xmlWFile+" with "+xslCharactersTokenizer);
@@ -188,7 +188,7 @@
 			} 
 
 			System.out.println("Applying "+xslCharactersIdentifier+" to "+xmlWCFile+"...");
-			if (monitor != null) monitor.worked(1, "Applying "+xslCharactersIdentifier+" to "+xmlWCFile+"...");
+			if (monitor != null) {monitor.worked(1); monitor.subTask("Applying "+xslCharactersIdentifier+" to "+xmlWCFile+"...");}
 			builder = new ApplyXsl2(xslCharactersIdentifier);
 			if (!builder.process(xmlWCFile, xmlWCFile)) {
 				System.out.println("Failed to process "+xmlWCFile+" with "+xslCharactersIdentifier);
@@ -196,7 +196,7 @@
 			}
 
 			System.out.println("Applying "+xslZones+" to "+xmlWFile+"...");
-			if (monitor != null) monitor.worked(15, "Applying "+xslZones+" to "+xmlWFile+"...");
+			if (monitor != null) {monitor.worked(15); monitor.subTask("Applying "+xslZones+" to "+xmlWFile+"...");}
 			builder = new ApplyXsl2(xslZones);
 			if (!builder.process(xmlWFile, null)) {
 				System.out.println("Failed to process "+xmlFileCopy+" with "+xslZones);
@@ -211,7 +211,7 @@
 			}
 
 			if (createArchive) {
-				if (monitor != null) monitor.worked(15, "Building Oriflamms binary project... ");
+				if (monitor != null) {monitor.worked(15); monitor.subTask("Building Oriflamms binary project... ");}
 				File zipFile = new File(xmlFileParentDirectory, projectName+".oriflamms");
 				zipFile.delete();
 				Zip.compress(projectDirectory, zipFile);
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/InitializeKnowledgeRepository.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/InitializeKnowledgeRepository.java	(revision 489)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/InitializeKnowledgeRepository.java	(revision 490)
@@ -10,6 +10,7 @@
 import org.eclipse.jface.viewers.IStructuredSelection;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.annotation.repository.KnowledgeRepository;
 import org.txm.annotation.repository.KnowledgeRepositoryManager;
 import org.txm.rcp.swt.dialog.UsernamePasswordDialog;
@@ -43,8 +44,8 @@
 	public static List<KnowledgeRepository> get(MainCorpus corpus) {
 		List<KnowledgeRepository> ret = new ArrayList<KnowledgeRepository>();
 		
-		for (String kr_name : corpus.getKnowledgeRepositoryNames()) {
-			KnowledgeRepository kr = corpus.getKnowledgeRepository(kr_name);
+		for (String kr_name : KRAnnotationEngine.getKnowledgeRepositoryNames(corpus)) {
+			KnowledgeRepository kr = KRAnnotationEngine.getKnowledgeRepository(corpus, kr_name);
 			if (kr == null) {
 				System.out.println("Warning '"+kr_name+"' KR is null. Please check KR configuration.");
 				continue;
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/ExportStandoff.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/ExportStandoff.java	(revision 489)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/ExportStandoff.java	(revision 490)
@@ -43,6 +43,7 @@
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.Toolbox;
 import org.txm.annotation.AnnotationManager;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.rcp.Messages;
 import org.txm.rcp.StatusLine;
@@ -98,7 +99,7 @@
 	}
 
 	public static boolean exportAnnotations(final MainCorpus corpus, final File resultZipFile) {
-		final AnnotationManager am = corpus.getAnnotationManager();
+		final AnnotationManager am = KRAnnotationEngine.getAnnotationManager(corpus);
 		if (am == null) return true; // nothing to do
 		
 		JobHandler saveJob = SaveAnnotations.save(corpus);
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/SaveAnnotations.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/SaveAnnotations.java	(revision 489)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/annotation/SaveAnnotations.java	(revision 490)
@@ -13,6 +13,7 @@
 import org.eclipse.swt.widgets.MessageBox;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.annotation.AnnotationManager;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.rcp.Messages;
 import org.txm.rcp.commands.CloseEditorsUsing;
 import org.txm.rcp.commands.workspace.UpdateCorpus;
@@ -42,10 +43,10 @@
 	}
 
 	public static JobHandler save(final MainCorpus corpus) {
-		final AnnotationManager am = corpus.getAnnotationManager();
+		final AnnotationManager am = KRAnnotationEngine.getAnnotationManager(corpus);
 		if (am == null) return null; // nothing to do
 		
-		if (!corpus.needToSaveAnnotations()) {
+		if (!KRAnnotationEngine.needToSaveAnnotations(corpus)) {
 			return null;
 		}
 
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/AnnotationSection.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/AnnotationSection.java	(revision 489)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/AnnotationSection.java	(revision 490)
@@ -12,6 +12,7 @@
 import org.eclipse.ui.forms.widgets.ScrolledForm;
 import org.eclipse.ui.forms.widgets.TableWrapData;
 import org.eclipse.ui.forms.widgets.TableWrapLayout;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.objects.BaseParameters;
 
 public class AnnotationSection extends ImportEditorSection {
@@ -54,7 +55,7 @@
 	public void update(BaseParameters params) {
 		if (this.section.isDisposed()) return;
 		if (params == null) return;
-		List<String> values = params.getKnowledgeRepositoryNames();
+		List<String> values = KRAnnotationEngine.getKnowledgeRepositoryNames(params);
 		
 		String value = params.getCorpusName()+DEFAULTNAMESUFFIX;
 		if (values.size() > 0) {
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/tests/AnnotationLookUp.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/tests/AnnotationLookUp.java	(revision 489)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/tests/AnnotationLookUp.java	(revision 490)
@@ -9,6 +9,7 @@
 import org.txm.annotation.Annotation;
 import org.txm.annotation.AnnotationManager;
 import org.txm.annotation.CQPAnnotationManager;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.annotation.repository.AnnotationType;
 import org.txm.annotation.repository.KnowledgeRepository;
 import org.txm.annotation.repository.KnowledgeRepositoryManager;
@@ -392,7 +393,7 @@
 			if (c == null) return;
 			InitializeKnowledgeRepository.get(c);
 			KnowledgeRepository kr = KnowledgeRepositoryManager.getKnowledgeRepository("localkrfortesting", c);
-			AnnotationManager am = c.getAnnotationManager();
+			AnnotationManager am = KRAnnotationEngine.getAnnotationManager(c);
 
 			for (String test : args) {
 				System.out.println("******************** *** ********************");
Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 489)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 490)
@@ -3,7 +3,10 @@
  */
 package org.txm.core.results;
 
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
 import java.util.ArrayList;
+import java.util.Date;
 import java.util.UUID;
 
 import org.osgi.framework.FrameworkUtil;
@@ -22,10 +25,10 @@
 public abstract class TXMResult implements Cloneable {
 	
 	/**
-	 * Unique ID of the object.
+	 * Unique ID of the object built with : class + date + number
 	 */
 	protected String uniqueID;
-	
+	public static final DateFormat ID_TIME_FORMAT = new SimpleDateFormat("YYYYMMDD");
 	/**
 	 * The weight, essentially used for sorting purpose.
 	 */
@@ -80,8 +83,9 @@
 	public TXMResult(TXMResult parent, TXMParameters parameters) {
 		
 		// FIXME: discuss about this method and validate it. Also discuss about a getInternalName() method that should also return an unique ID.
-		this.uniqueID = this.getClass().getName() + '@' + Integer.toHexString(System.identityHashCode(this)) + "_" + UUID.randomUUID();
 		
+		this.uniqueID = this.getClass().getName() + '@' + ID_TIME_FORMAT.format(new Date(System.currentTimeMillis())) + "_" + UUID.randomUUID();
+		
 		this.weight = 0;
 		this.visible = true;
 		if(parent != null)	{
@@ -161,6 +165,10 @@
 		return TXMPreferences.getString(key, this.parameters, this, this.preferencesNodeQualifier);
 	}
 	
+	public void saveParameters() {
+		TXMPreferences.putLocalParameters(this, this.parameters);
+	}
+	
 	/**
 	 * Deletes the object from its parent, also deletes the children.
 	 * The <code>TXMResult.clean()</code> methods of this result and children results are applied before the deletion.
@@ -319,10 +327,10 @@
 	synchronized public ArrayList<TXMResult> getResults(Class type, boolean onlyVisible)	{
 		return TXMResult.getNodes(this.children, type, onlyVisible);
 	}
-	
 
 	/**
 	 * Gets the children of all the branch in a flat list.
+	 * 
 	 * @return
 	 */
 	synchronized protected ArrayList<TXMResult> getDeepResults(TXMResult parent, ArrayList<TXMResult> results)	{
Index: tmp/org.txm.core/src/java/org/txm/objects/Base.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Base.java	(revision 489)
+++ tmp/org.txm.core/src/java/org/txm/objects/Base.java	(revision 490)
@@ -48,7 +48,7 @@
 
 import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.utils.logger.Log;
 import org.txm.utils.zip.Zip;
 import org.w3c.dom.Document;
@@ -272,7 +272,7 @@
 	 * @param exportzip the exportzip
 	 * @return true, if successful
 	 */
-	public boolean export(File exportzip, ProgressWatcher monitor) {
+	public boolean export(File exportzip, IProgressMonitor monitor) {
 		File binarydir = this.params.paramFile.getParentFile();
 
 		if (binarydir.exists() && exportzip.getParentFile().exists()) {
